
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string Name_Expert       = "Rsi Trader";
extern bool   EcnBroker         = true;
extern bool   UseAutoMagic      = true;
extern int    ManualMagic       = 28282828;  
extern double lStopLoss         = 100;
extern double sStopLoss         = 100;
extern double lTakeProfit       = 100;
extern double sTakeProfit       = 100;
extern double lTrailingStop     = 0;
extern double sTrailingStop     = 0;
extern int    Slippage          = 5;
extern double Lots              = 0.1;
extern double MaximumRisk       = 0;
extern double DecreaseFactor    = 3;

extern int    RsiPeriod         = 14;
extern double longbelow         = 5;
extern double shortabove        = 75;
extern int    bar               = 1;

extern bool   UseRsiClose       = true;
extern int    RsiClPeriod       = 14;
extern double longcloseabove    = 95;
extern double shortclosebelow   = 45;
extern int    clbar             = 1;

extern string __fricl           = "Setting for friday positions close";
extern bool   CloseOnFriday     = false;
extern int    FridayCloseHour   = 21; // will be used only if CloseOnFriday == true
extern int    FridayCloseMinute = 59; // will be used only if CloseOnFriday == true

extern bool   ShowAlerts        = false;
extern color  clOpenBuy         = Blue;
extern color  clCloseBuy        = Aqua;
extern color  clOpenSell        = Red;
extern color  clCloseSell       = Violet;

//
//
//
//
//

string s_symbol;

int    MAGIC;
int digit; 

double point = 1;

//
//
//
//
//

int init() 
{
  s_symbol = Symbol();
  
  digit = MarketInfo(s_symbol,MODE_DIGITS);
  if (digit==2 || digit==4) point = 1;
  if (digit==3 || digit==5) point = 10;
  if (digit==6)             point = 100;
  
  if (UseAutoMagic) MAGIC = GetMagic();
              else  MAGIC = ManualMagic;  
              
return(0);
}

//
//
//
//
//

int deinit() { Comment(""); return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   
   if (CloseOnFriday && TimeDayOfWeek(TimeCurrent())==5)
   {
     if (TimeHour(TimeCurrent()) > FridayCloseHour ||
        (TimeHour(TimeCurrent())== FridayCloseHour && TimeMinute(TimeCurrent())>= FridayCloseMinute))
     {
       for(int i=OrdersTotal()-1; i>=0; i--)
  	    { 
     	   OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()     != s_symbol)    continue;
            if(OrderMagicNumber()!= MAGIC)       continue;

            if(OrderType()==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE); continue; }
            if(OrderType()==OP_SELL){ OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE); continue; }
       }
       return(0);
     }
   }
   
   //
   //
   //
   //
   //
   
   double vla = iRSI(s_symbol,0,RsiPeriod,PRICE_CLOSE,bar);
   
   //
   //
   //
   //
   //
   
   if (!ExistPositions())
   {
      
     if(vla<longbelow)  
     {
       OpenBuy();
       return(0);
     }

     if(vla>shortabove)
     {
       OpenSell();
       return(0);
     }
      
   }
   
   if (lTrailingStop > 0) TrailingPositionsBuy();
   if (sTrailingStop > 0) TrailingPositionsSell();
   if (UseRsiClose)       CheckForClose();
return (0);
}

//
//
//
//
//

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) {
				return(true);
			}
		} 
   }
return(false);
}

//
//
//
//
//

void TrailingPositionsBuy() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice()     > Point * lTrailingStop * point) { 
                  if (OrderStopLoss() < Bid - Point * lTrailingStop * point) 
                      ModifyStopLoss(Bid-Point*lTrailingStop*point); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask   > Point * sTrailingStop * point) { 
                  if (OrderStopLoss() > Ask + Point * sTrailingStop * point || OrderStopLoss() == 0)  
                      ModifyStopLoss(Ask+Point*sTrailingStop*point); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(ldStopLoss,digit),OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  if (ShowAlerts   == true) Alert(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

//
//
//
//
//

void OpenBuy() 
{ 
    
   double lbStop = 0; if (lStopLoss>0)   lbStop = NormalizeDouble(Ask-lStopLoss  *Point*point,digit);
   double lbTake = 0; if (lTakeProfit>0) lbTake = NormalizeDouble(Ask+lTakeProfit*Point*point,digit);
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*point,lbStop,lbTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*point,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket   >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       

}

//
//
//
//
//

void OpenSell() 
{ 
   double lsStop = 0; if (sStopLoss>0)   lsStop = NormalizeDouble(Bid+sStopLoss  *Point*point,digit);
   double lsTake = 0; if (sTakeProfit>0) lsTake = NormalizeDouble(Bid-sTakeProfit*Point*point,digit);
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*point,lsStop,lsTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*point,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if (sellTicket    >= 0)
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
         }
    }		       
} 

//
//
//
//
//

void CheckForClose()  
{
   RefreshRates();
   double clvla = iRSI(s_symbol,0,RsiClPeriod,PRICE_CLOSE,clbar);
   
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGIC)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (clvla>longcloseabove) 
        {
           bool buyClose = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*point,clCloseBuy);
           if (buyClose == false)
           {
             int ErrorCode   = GetLastError();
             string ErrDesc  = ErrorDescription(ErrorCode);

             string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts  == true) Alert(ErrAlert);

             string ErrLog   = StringConcatenate("Bid: ",Bid," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
           }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (clvla<shortclosebelow) 
        {
          bool sellClose = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*point,clCloseSell); 
          if (sellClose  == false)
          {
             ErrorCode = GetLastError();
             ErrDesc   = ErrorDescription(ErrorCode);

             ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts == true) Alert(ErrAlert);

             ErrLog   = StringConcatenate("Ask: ",Ask," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
          }
        }
        break;
      }
   }
}

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
     lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
        if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
        if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
        //
        //
        //
        //
        //
      
        if(OrderProfit() > 0) break;
        if(OrderProfit() < 0) losses++;
        }
        if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
return(lot);
} 

//
//
//
//
//

int GetMagic() 
{

   if (StringFind(s_symbol, "CADJPY") >= 0) return(1944921);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(1944922);
   
   if (StringFind(s_symbol, "GOLD"  ) >= 0) return(1944931);
   if (StringFind(s_symbol, "SILVER") >= 0) return(1944932);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(1944941);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(1944942);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(1944951);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(1944961);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(1944962);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(1944963);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(1944964);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(1944965);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(1944966);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(1944967);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(1944971);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(1944972);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(1944973);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(1944981);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(1944982);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(1944983);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(1944991);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(1944992);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(1944993);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(1944994);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(1944995);
   
return(ManualMagic);
}



